indexing
   description: "This is a really crappy way of picking"
   "the color and fractal types."
   status: "Free according to the GPL license (see COPYING)"
   date: "$Date$"
   revision: "$Revision$"
   author: "Mark Arrasmith <arrasmith@math.twsu.edu>"
   

class EFRACTAL_SELECTION

inherit
   EFRACTAL_COLOR_FUNCTIONS
   EFRACTAL_TYPE_FUNCTIONS

feature -- Select type and color functions

	generate_fractal(x,y: DOUBLE): INTEGER is
		local
		temp: INTEGER
		xo,yo,a,b: DOUBLE
		do
			if config.do_julia = True then
			  a := config.julia_x
			  b := config.julia_y
			  xo := x
			  yo := y
			else
			  a := x
			  b := y
			  xo := 0
			  yo := 0
			end

			if config.type.is_equal("mandel") then
			temp := mandel_julia(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("cube_mandel") then
			temp := cube_mandel_julia(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("forth_mandel") then
			temp := forth_mandel_julia(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("barnsley_1") then
			temp := barnsley_1(xo,yo,a,b,config.total)

			elseif config.type.is_equal("barnsley_2") then
			temp := barnsley_2(xo,yo,a,b,config.total)

			elseif config.type.is_equal("barnsley_3") then
			temp := barnsley_3(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("manowar") then
			temp := manowar(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("magnet_1") then
			temp := magnet_1(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("oops") then
			temp := oops(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("spider") then
			temp := spider(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("sine") then
			temp := sine(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("cosine") then
			temp := cosine(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("c_cosine") then
			temp := c_cosine(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("c_exp") then
			temp := c_exp(xo,yo,a,b,config.total)
			
			elseif config.type.is_equal("popcorn") then
			temp := popcorn(a,b,config.total)
			
			elseif config.type.is_equal("lyapunov") then
			temp := lyapunov(a,b,config.total)
			temp := temp + config.total
			
			
			end

			temp :=	(config.total - temp).abs

			if temp = config.total then

				if config.color_inside.is_equal("max") then
				temp := c_iter(config.color_x,config.color_y,temp)

				elseif config.color_inside.is_equal("zmag") then
				temp := c_zmag(config.color_x,config.color_y,temp)

				elseif config.color_inside.is_equal("zmag_diff") then
				temp := c_zmag(x - config.color_x,y - config.color_y,temp)

				elseif config.color_inside.is_equal("atan") then
				temp := c_atan(config.color_x,config.color_y,temp)

				end

			else
				if config.color_outside.is_equal("iteration") then
				temp := c_iter(config.color_x,config.color_y,temp)

				elseif config.color_outside.is_equal("real") then
				temp := c_real(config.color_x,config.color_y,temp)

				elseif config.color_outside.is_equal("imaginary") then
				temp := c_imag(config.color_x,config.color_y,temp)

				elseif config.color_outside.is_equal("sum") then
				temp := c_sum(config.color_x,config.color_y,temp)
			
				elseif config.color_outside.is_equal("times") then
				temp := c_times(config.color_x,config.color_y,temp)
			
				elseif config.color_outside.is_equal("atan") then
				temp := c_atan(config.color_x,config.color_y,temp)

				elseif config.color_outside.is_equal("taper") then
				temp := c_taper(config.color_x,config.color_y,temp)

				end

			end
			Result := temp
 
		end -- generate_fractal

end --class EFRACTAL_SELECTION
